#!/bin/bash

scriptdir=$(dirname "$0")

###### Install On Laptop ? ###################
echo -e "\033[1;32;40m"
echo "==============================================="
echo "==============================================="
echo "ARE YOU INSTALLING THIS ARCHLINUX ON LAPTOP ?"
echo "==============================================="
echo -e "===============================================\033[1;31;40m"
select LT in "Yes" "No" ; do
echo -e "\033[0m"
break
done

###### Select Videocard Drivers ############################
echo -e "\033[1;32;40m"
echo "=============================================="
echo "=============================================="
echo " CHOOSE YOUR VIDEOCARD ?"
echo "=============================================="
echo -e "===============================================\033[1;31;40m"
select VC in "all" "ati" "intel" "nouveau" "nv" "vesa" "vmware" "nvidia(official)" "custom" ; do
[[ $VC == "all" ]] && cat ${scriptdir}/videoall > ${scriptdir}/drivers
[[ $VC == "ati" ]] && echo -e "xf86-video-ati\nati-dri\n" > ${scriptdir}/drivers
[[ $VC == "intel" ]] && echo -e "xf86-video-intel\nintel-dri\n" > ${scriptdir}/drivers
[[ $VC == "nouveau" ]] && echo "xf86-video-nouveau" > ${scriptdir}/drivers
[[ $VC == "nv" ]] && echo "xf86-video-nv" > ${scriptdir}/drivers
[[ $VC == "vesa" ]] && echo "xf86-video-vesa" > ${scriptdir}/drivers
[[ $VC == "vmware" ]] && echo "xf86-video-vmware" > ${scriptdir}/drivers
[[ $VC == "nvidia(official)" ]] && echo -e "nvidia-utils\nnvidia\n" > ${scriptdir}/drivers
[[ $VC == "custom" ]] && (echo -e "Please Input Your Driver Package Name :\n(Separate With [SPACE] )"; read DP; echo "$DP" > ${scriptdir}/drivers)
echo -e "\033[0m"
break
done

###### Install on virtualbox ? ##################
echo -e "\033[1;32;40m"
echo "================================================="
echo "================================================="
echo "ARE YOU INSTALLING THIS ARCHLINUX  ON VIRTUALBOX ?"
echo "================================================="
echo -e "=================================================\033[1;31;40m"
select VB in "Yes" "No"; do
[[ $VB == "Yes" ]] && echo "virtualbox-archlinux-additions" >> ${scriptdir}/drivers && echo -e "vboxguest\nvboxsf\nvboxvideo\n" > /etc/modules-load.d/vbox.conf
echo -e "\033[0m"
break
done

###### Create A New User ? #############
echo -e "\033[1;32;40m"
echo "==============================================="
echo "==============================================="
echo "DO YOU WANT TO CREATE A NEW USER ?"
echo "==============================================="
echo -e "===============================================\033[1;31;40m"
select NUSR in "Yes" "No"; do
echo -e "\033[0m"
break
done
if [[ $NUSR == "Yes" ]]; then
echo -e "\033[1;32;40m"
echo "==============================================="
echo "==============================================="
echo "Please input new username and password:"
echo "==============================================="
echo "==============================================="
echo -ne "\033[1;31;40mNew username:"
read NNAME
echo -ne "New password:"
read PASWD
echo -e "\033[0m"
fi

###### Add [archlinuxfr] Sourse #########################
cp -r ${scriptdir}/pacman.conf /etc/pacman.conf
pacman -Syu

###################INSTALL NORMAL SOFTWARE#########################
pacman -S --needed --noconfirm $(< ${scriptdir}/pkglist_pacman)
for NORM in $(< ${scriptdir}/pkglist_pacman)
do
	while [[ -z $(pacman -Q $NORM) ]];do
		pacman -S --noconfirm $NORM
	done
done

###################INSTALL DRIVERS#################################
pacman -Sf --needed --noconfirm $(< ${scriptdir}/drivers)
for DRI in $(< ${scriptdir}/drivers)
do
	while [[ -z $(pacman -Q $DRI) ]];do
		pacman -Sf --noconfirm $DRI
	done
done

###################INSTALL NOTEBOOK'S DRIVERS######################
if [[ $LT == "Yes" ]]; then
for LTDRI in $(< ${scriptdir}/laptop)
do
	while [[ -z $(pacman -Q $LTDRI) ]];do
		yaourt -S --noconfirm $LTDRI
	done
done
fi

###################DELETE ARCHLINUXFR SOURCE#######################
sed -i '/archlinuxfr/ d' /etc/pacman.conf
sed -i '/repo.*fr/ d' /etc/pacman.conf
pacman -Syyu



###################INSTALL AUR SOFTWARE############################
for AUR in $(< ${scriptdir}/pkglist_aur)
do
	while [[ -z $(pacman -Q $AUR) ]];do
		yaourt -S --noconfirm $AUR
	done
done


###################COPY SOME FILES#################################
cp -r ${scriptdir}/etc/ /
cp -r ${scriptdir}/usr/ /

###################CREATE A NEW USER###############################
if [[ $NUSR == "Yes" ]]; then
useradd --create-home --skel /etc/skel --gid users --groups "audio,video,lp,wheel,power,storage,optical,network,log" --shell /bin/bash $NNAME
(echo "$PASWD"; sleep 1; echo "$PASWD")|passwd $NNAME
sed -i "/^#*default_user/ c\default_user $NNAME" /etc/slim.conf
fi

###################SET DAEMONS,INITTAB,SUDOERS#####################
cp /etc/rc.conf /etc/rc.conf.old
sed -i '/^DAEMONS=/ c\DAEMONS=(dbus networkmanager syslog-ng @alsa)' /etc/rc.conf 
sed -i '/^id:3:/ s/^/#/; /id:5/ s/#*//; /^x:5:/ s/^/#/; /slim >/ s/#*//' /etc/inittab 
echo "%wheel ALL=(ALL) NOPASSWD: ALL" >> /etc/sudoers.d/g_wheel

###################REMOVE USELESS SHORTCUTS########################
echo "NoDisplay=true" >> /usr/share/applications/{7zFM.desktop,bssh.desktop,bvnc.desktop,avahi-discover.desktop,qv4l2.desktop,dconf-editor.desktop}

echo -e "\033[1;32;40m"
echo "========================================"
echo "========================================"
echo "== YOU HAVE COMPLETE THE INSTALLATION =="
echo "== ENJOY THE NEW SYSTEM !             =="
echo "========================================"
echo "========================================"
echo -e "\033[0m"
